// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/PowerFactors.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Electricity {

  /// <summary>Holder for reflection information generated from telemetry/PowerFactors.proto</summary>
  public static partial class PowerFactorsReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/PowerFactors.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static PowerFactorsReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Chx0ZWxlbWV0cnkvUG93ZXJGYWN0b3JzLnByb3RvEgtlbGVjdHJpY2l0eSKf",
            "BAoMUG93ZXJGYWN0b3JzEhQKDGFjdGl2ZV9wb3dlchgBIAEoCRIWCg5hcHBh",
            "cmVudF9wb3dlchgCIAEoCRIWCg5yZWFjdGl2ZV9wb3dlchgDIAEoCRIUCgxw",
            "b3dlcl9mYWN0b3IYBCABKAkSDwoHY29zX3BoaRgFIAEoCRIOCgZ0Z19waGkY",
            "BiABKAkSHgoWYWN0aXZlX2VuZXJneV9wb3NpdGl2ZRgHIAEoCRIeChZhY3Rp",
            "dmVfZW5lcmd5X25lZ2F0aXZlGAggASgJEiAKGHJlYWN0aXZlX2VuZXJneV9w",
            "b3NpdGl2ZRgJIAEoCRIgChhyZWFjdGl2ZV9lbmVyZ3lfbmVnYXRpdmUYCiAB",
            "KAkSOQoLc2FtcGxlX3R5cGUYFCABKA4yJC5lbGVjdHJpY2l0eS5Qb3dlckZh",
            "Y3RvcnMuU2FtcGxlVHlwZRIuCgVwaGFzZRgVIAEoDjIfLmVsZWN0cmljaXR5",
            "LlBvd2VyRmFjdG9ycy5QaGFzZSInCgpTYW1wbGVUeXBlEgcKA0FWRxAAEgcK",
            "A01JThABEgcKA01BWBACInoKBVBoYXNlEgYKAkwxEAASBgoCTDIQARIGCgJM",
            "MxACEggKBEwxX04QAxIICgRMMl9OEAQSCAoETDNfThAFEggKBFBFX04QBhIF",
            "CgFOEAcSCQoFTDFfTDIQCBIJCgVMMl9MMxAJEgkKBUwzX0wxEAoSCQoFVE9U",
            "QUwQC0J4Chtjb20uY29kaWJseS5tb2RlbC50ZWxlbWV0cnlCEVBvd2VyRmFj",
            "dG9yc1Byb3RvygIbRG9tYWluTW9kZWxcUHJvdG9cVGVsZW1ldHJ54gInRG9t",
            "YWluTW9kZWxcUHJvdG9cVGVsZW1ldHJ5XEdQQk1ldGFkYXRhYgZwcm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Electricity.PowerFactors), global::Electricity.PowerFactors.Parser, new[]{ "ActivePower", "ApparentPower", "ReactivePower", "PowerFactor", "CosPhi", "TgPhi", "ActiveEnergyPositive", "ActiveEnergyNegative", "ReactiveEnergyPositive", "ReactiveEnergyNegative", "SampleType", "Phase" }, null, new[]{ typeof(global::Electricity.PowerFactors.Types.SampleType), typeof(global::Electricity.PowerFactors.Types.Phase) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class PowerFactors : pb::IMessage<PowerFactors>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<PowerFactors> _parser = new pb::MessageParser<PowerFactors>(() => new PowerFactors());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<PowerFactors> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Electricity.PowerFactorsReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public PowerFactors() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public PowerFactors(PowerFactors other) : this() {
      activePower_ = other.activePower_;
      apparentPower_ = other.apparentPower_;
      reactivePower_ = other.reactivePower_;
      powerFactor_ = other.powerFactor_;
      cosPhi_ = other.cosPhi_;
      tgPhi_ = other.tgPhi_;
      activeEnergyPositive_ = other.activeEnergyPositive_;
      activeEnergyNegative_ = other.activeEnergyNegative_;
      reactiveEnergyPositive_ = other.reactiveEnergyPositive_;
      reactiveEnergyNegative_ = other.reactiveEnergyNegative_;
      sampleType_ = other.sampleType_;
      phase_ = other.phase_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public PowerFactors Clone() {
      return new PowerFactors(this);
    }

    /// <summary>Field number for the "active_power" field.</summary>
    public const int ActivePowerFieldNumber = 1;
    private string activePower_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActivePower {
      get { return activePower_; }
      set {
        activePower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "apparent_power" field.</summary>
    public const int ApparentPowerFieldNumber = 2;
    private string apparentPower_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ApparentPower {
      get { return apparentPower_; }
      set {
        apparentPower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "reactive_power" field.</summary>
    public const int ReactivePowerFieldNumber = 3;
    private string reactivePower_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ReactivePower {
      get { return reactivePower_; }
      set {
        reactivePower_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "power_factor" field.</summary>
    public const int PowerFactorFieldNumber = 4;
    private string powerFactor_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string PowerFactor {
      get { return powerFactor_; }
      set {
        powerFactor_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "cos_phi" field.</summary>
    public const int CosPhiFieldNumber = 5;
    private string cosPhi_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string CosPhi {
      get { return cosPhi_; }
      set {
        cosPhi_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "tg_phi" field.</summary>
    public const int TgPhiFieldNumber = 6;
    private string tgPhi_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TgPhi {
      get { return tgPhi_; }
      set {
        tgPhi_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "active_energy_positive" field.</summary>
    public const int ActiveEnergyPositiveFieldNumber = 7;
    private string activeEnergyPositive_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActiveEnergyPositive {
      get { return activeEnergyPositive_; }
      set {
        activeEnergyPositive_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "active_energy_negative" field.</summary>
    public const int ActiveEnergyNegativeFieldNumber = 8;
    private string activeEnergyNegative_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ActiveEnergyNegative {
      get { return activeEnergyNegative_; }
      set {
        activeEnergyNegative_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "reactive_energy_positive" field.</summary>
    public const int ReactiveEnergyPositiveFieldNumber = 9;
    private string reactiveEnergyPositive_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ReactiveEnergyPositive {
      get { return reactiveEnergyPositive_; }
      set {
        reactiveEnergyPositive_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "reactive_energy_negative" field.</summary>
    public const int ReactiveEnergyNegativeFieldNumber = 10;
    private string reactiveEnergyNegative_ = "";
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string ReactiveEnergyNegative {
      get { return reactiveEnergyNegative_; }
      set {
        reactiveEnergyNegative_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }

    /// <summary>Field number for the "sample_type" field.</summary>
    public const int SampleTypeFieldNumber = 20;
    private global::Electricity.PowerFactors.Types.SampleType sampleType_ = global::Electricity.PowerFactors.Types.SampleType.Avg;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.PowerFactors.Types.SampleType SampleType {
      get { return sampleType_; }
      set {
        sampleType_ = value;
      }
    }

    /// <summary>Field number for the "phase" field.</summary>
    public const int PhaseFieldNumber = 21;
    private global::Electricity.PowerFactors.Types.Phase phase_ = global::Electricity.PowerFactors.Types.Phase.L1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.PowerFactors.Types.Phase Phase {
      get { return phase_; }
      set {
        phase_ = value;
      }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as PowerFactors);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(PowerFactors other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (ActivePower != other.ActivePower) return false;
      if (ApparentPower != other.ApparentPower) return false;
      if (ReactivePower != other.ReactivePower) return false;
      if (PowerFactor != other.PowerFactor) return false;
      if (CosPhi != other.CosPhi) return false;
      if (TgPhi != other.TgPhi) return false;
      if (ActiveEnergyPositive != other.ActiveEnergyPositive) return false;
      if (ActiveEnergyNegative != other.ActiveEnergyNegative) return false;
      if (ReactiveEnergyPositive != other.ReactiveEnergyPositive) return false;
      if (ReactiveEnergyNegative != other.ReactiveEnergyNegative) return false;
      if (SampleType != other.SampleType) return false;
      if (Phase != other.Phase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (ActivePower.Length != 0) hash ^= ActivePower.GetHashCode();
      if (ApparentPower.Length != 0) hash ^= ApparentPower.GetHashCode();
      if (ReactivePower.Length != 0) hash ^= ReactivePower.GetHashCode();
      if (PowerFactor.Length != 0) hash ^= PowerFactor.GetHashCode();
      if (CosPhi.Length != 0) hash ^= CosPhi.GetHashCode();
      if (TgPhi.Length != 0) hash ^= TgPhi.GetHashCode();
      if (ActiveEnergyPositive.Length != 0) hash ^= ActiveEnergyPositive.GetHashCode();
      if (ActiveEnergyNegative.Length != 0) hash ^= ActiveEnergyNegative.GetHashCode();
      if (ReactiveEnergyPositive.Length != 0) hash ^= ReactiveEnergyPositive.GetHashCode();
      if (ReactiveEnergyNegative.Length != 0) hash ^= ReactiveEnergyNegative.GetHashCode();
      if (SampleType != global::Electricity.PowerFactors.Types.SampleType.Avg) hash ^= SampleType.GetHashCode();
      if (Phase != global::Electricity.PowerFactors.Types.Phase.L1) hash ^= Phase.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (ActivePower.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(ActivePower);
      }
      if (ApparentPower.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(ApparentPower);
      }
      if (ReactivePower.Length != 0) {
        output.WriteRawTag(26);
        output.WriteString(ReactivePower);
      }
      if (PowerFactor.Length != 0) {
        output.WriteRawTag(34);
        output.WriteString(PowerFactor);
      }
      if (CosPhi.Length != 0) {
        output.WriteRawTag(42);
        output.WriteString(CosPhi);
      }
      if (TgPhi.Length != 0) {
        output.WriteRawTag(50);
        output.WriteString(TgPhi);
      }
      if (ActiveEnergyPositive.Length != 0) {
        output.WriteRawTag(58);
        output.WriteString(ActiveEnergyPositive);
      }
      if (ActiveEnergyNegative.Length != 0) {
        output.WriteRawTag(66);
        output.WriteString(ActiveEnergyNegative);
      }
      if (ReactiveEnergyPositive.Length != 0) {
        output.WriteRawTag(74);
        output.WriteString(ReactiveEnergyPositive);
      }
      if (ReactiveEnergyNegative.Length != 0) {
        output.WriteRawTag(82);
        output.WriteString(ReactiveEnergyNegative);
      }
      if (SampleType != global::Electricity.PowerFactors.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.PowerFactors.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (ActivePower.Length != 0) {
        output.WriteRawTag(10);
        output.WriteString(ActivePower);
      }
      if (ApparentPower.Length != 0) {
        output.WriteRawTag(18);
        output.WriteString(ApparentPower);
      }
      if (ReactivePower.Length != 0) {
        output.WriteRawTag(26);
        output.WriteString(ReactivePower);
      }
      if (PowerFactor.Length != 0) {
        output.WriteRawTag(34);
        output.WriteString(PowerFactor);
      }
      if (CosPhi.Length != 0) {
        output.WriteRawTag(42);
        output.WriteString(CosPhi);
      }
      if (TgPhi.Length != 0) {
        output.WriteRawTag(50);
        output.WriteString(TgPhi);
      }
      if (ActiveEnergyPositive.Length != 0) {
        output.WriteRawTag(58);
        output.WriteString(ActiveEnergyPositive);
      }
      if (ActiveEnergyNegative.Length != 0) {
        output.WriteRawTag(66);
        output.WriteString(ActiveEnergyNegative);
      }
      if (ReactiveEnergyPositive.Length != 0) {
        output.WriteRawTag(74);
        output.WriteString(ReactiveEnergyPositive);
      }
      if (ReactiveEnergyNegative.Length != 0) {
        output.WriteRawTag(82);
        output.WriteString(ReactiveEnergyNegative);
      }
      if (SampleType != global::Electricity.PowerFactors.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.PowerFactors.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (ActivePower.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActivePower);
      }
      if (ApparentPower.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ApparentPower);
      }
      if (ReactivePower.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ReactivePower);
      }
      if (PowerFactor.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(PowerFactor);
      }
      if (CosPhi.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(CosPhi);
      }
      if (TgPhi.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TgPhi);
      }
      if (ActiveEnergyPositive.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActiveEnergyPositive);
      }
      if (ActiveEnergyNegative.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ActiveEnergyNegative);
      }
      if (ReactiveEnergyPositive.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ReactiveEnergyPositive);
      }
      if (ReactiveEnergyNegative.Length != 0) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(ReactiveEnergyNegative);
      }
      if (SampleType != global::Electricity.PowerFactors.Types.SampleType.Avg) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) SampleType);
      }
      if (Phase != global::Electricity.PowerFactors.Types.Phase.L1) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) Phase);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(PowerFactors other) {
      if (other == null) {
        return;
      }
      if (other.ActivePower.Length != 0) {
        ActivePower = other.ActivePower;
      }
      if (other.ApparentPower.Length != 0) {
        ApparentPower = other.ApparentPower;
      }
      if (other.ReactivePower.Length != 0) {
        ReactivePower = other.ReactivePower;
      }
      if (other.PowerFactor.Length != 0) {
        PowerFactor = other.PowerFactor;
      }
      if (other.CosPhi.Length != 0) {
        CosPhi = other.CosPhi;
      }
      if (other.TgPhi.Length != 0) {
        TgPhi = other.TgPhi;
      }
      if (other.ActiveEnergyPositive.Length != 0) {
        ActiveEnergyPositive = other.ActiveEnergyPositive;
      }
      if (other.ActiveEnergyNegative.Length != 0) {
        ActiveEnergyNegative = other.ActiveEnergyNegative;
      }
      if (other.ReactiveEnergyPositive.Length != 0) {
        ReactiveEnergyPositive = other.ReactiveEnergyPositive;
      }
      if (other.ReactiveEnergyNegative.Length != 0) {
        ReactiveEnergyNegative = other.ReactiveEnergyNegative;
      }
      if (other.SampleType != global::Electricity.PowerFactors.Types.SampleType.Avg) {
        SampleType = other.SampleType;
      }
      if (other.Phase != global::Electricity.PowerFactors.Types.Phase.L1) {
        Phase = other.Phase;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            ActivePower = input.ReadString();
            break;
          }
          case 18: {
            ApparentPower = input.ReadString();
            break;
          }
          case 26: {
            ReactivePower = input.ReadString();
            break;
          }
          case 34: {
            PowerFactor = input.ReadString();
            break;
          }
          case 42: {
            CosPhi = input.ReadString();
            break;
          }
          case 50: {
            TgPhi = input.ReadString();
            break;
          }
          case 58: {
            ActiveEnergyPositive = input.ReadString();
            break;
          }
          case 66: {
            ActiveEnergyNegative = input.ReadString();
            break;
          }
          case 74: {
            ReactiveEnergyPositive = input.ReadString();
            break;
          }
          case 82: {
            ReactiveEnergyNegative = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.PowerFactors.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.PowerFactors.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            ActivePower = input.ReadString();
            break;
          }
          case 18: {
            ApparentPower = input.ReadString();
            break;
          }
          case 26: {
            ReactivePower = input.ReadString();
            break;
          }
          case 34: {
            PowerFactor = input.ReadString();
            break;
          }
          case 42: {
            CosPhi = input.ReadString();
            break;
          }
          case 50: {
            TgPhi = input.ReadString();
            break;
          }
          case 58: {
            ActiveEnergyPositive = input.ReadString();
            break;
          }
          case 66: {
            ActiveEnergyNegative = input.ReadString();
            break;
          }
          case 74: {
            ReactiveEnergyPositive = input.ReadString();
            break;
          }
          case 82: {
            ReactiveEnergyNegative = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.PowerFactors.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.PowerFactors.Types.Phase) input.ReadEnum();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the PowerFactors message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum SampleType {
        [pbr::OriginalName("AVG")] Avg = 0,
        [pbr::OriginalName("MIN")] Min = 1,
        [pbr::OriginalName("MAX")] Max = 2,
      }

      public enum Phase {
        [pbr::OriginalName("L1")] L1 = 0,
        [pbr::OriginalName("L2")] L2 = 1,
        [pbr::OriginalName("L3")] L3 = 2,
        [pbr::OriginalName("L1_N")] L1N = 3,
        [pbr::OriginalName("L2_N")] L2N = 4,
        [pbr::OriginalName("L3_N")] L3N = 5,
        [pbr::OriginalName("PE_N")] PeN = 6,
        [pbr::OriginalName("N")] N = 7,
        [pbr::OriginalName("L1_L2")] L1L2 = 8,
        [pbr::OriginalName("L2_L3")] L2L3 = 9,
        [pbr::OriginalName("L3_L1")] L3L1 = 10,
        [pbr::OriginalName("TOTAL")] Total = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
